/*
 * Tabs are 4 symbols wide due to stupid Windows function names...
 * ---------------------------------------------------------------
 *
 * Copyright (c) 2010 KSI Labs, LLC. All rights reserved.
 * Written by Sergey Kubushyn <ksi@koi8.net>, <ksi@ksilabs.com>.
 *
 * File: utils.h
 *
 * Utility routines for WDM driver for KSI Labs, LLC CENTIPEDE PCI Board.
 *
 * Please read documentation or go to http://www.ksilabs.com for further info.
 */

/*
 * 						LICENSE and Terms of Use.
 *
 * First of all, this is NOT GPL or Free Software. It is open so you have
 * all the source code for the Engine. There is also VHDL source code for
 * CENTIPEDE board CPLD that is available from KSI Labs, LLC website,
 * http://www.ksilabs.com.
 *
 * As for this particular code, Windows Mach3 Engine, you are free to use it,
 * make any modifications to customize it for your own needs, fix inevitable
 * bugs, port it to other CNC software and do anything else as long as your
 * derivative work that is based on this code or uses parts or pieces thereof
 * is made to be used with any KSI Labs, LLC products.
 *
 * We do NOT grant you a permission to use any parts of this software in any
 * products that are designed for products not manufactured or distributed
 * by KSI Labs, LLC. We might give such a permission on case-by-case basis
 * but it is not legal to use this software or bits and pieces thereof with
 * products not coming from KSI Labs, LLC without our explicit written
 * permission.
 *
 * The original copyright notices must be included in all derivative works.
 * You do NOT have to ask our permission to make any modifications to this
 * code and you are not under obligation to give us any of your work back
 * as long as you are using it for your own needs.
 *
 * However we do NOT give our permission to distribute your derivative work
 * unless all original copyrights are retained, all the conditions of this
 * license are met (use only with KSI Labs, LLC products) and full source
 * code for such derivative work is available for free to everybody without
 * any further conditions including but not limited to signing any kinds of
 * NDA. We explicitely deny permission to distribute any derivative work
 * based on this code with closed source binary-only fragments or include
 * bits or pieces of this code in such products.
 *
 * CNC software like Mach3 and likes is excluded from these requirements as
 * long as it does not include parts or pieces of this software into the
 * close source proprietary application proper. It can use shared memory
 * buffer, IOCTL calls, etc. to communicate with this Engine or the one based
 * on it and keep all the software making those calls or working on that
 * buffer close source and proprietary as long as those calls/structures are
 * documented and that documentation is freely available to everybody without
 * any further conditions including but no limited to signing any kind of NDA.
 */

#ifndef _UTILS_H_
#define _UTILS_H_

typedef struct _FDO_DATA *PFDO_DATA;

//
// In this driver we are using a safe version vsnprintf, which is
// RtlStringCbVPrintfA. To use strsafe function on Win2K, we have to
// define NTSTRSAFE_LIB before including this header file and explicitly
// link to ntstrsafe.lib. If the driver is just target for XP and above,
// there is no define NTSTRSAFE_LIB and link to the lib.
//
//#define NTSTRSAFE_LIB
#include <ntstrsafe.h>

BOOLEAN ReadRegistryValue(PFDO_DATA FdoData, PWCHAR Name, PLONG Value);
BOOLEAN WriteRegistryValue(PFDO_DATA FdoData, PWCHAR Name, ULONG Value);
PCHAR PnPMinorFunctionString(UCHAR MinorFunction);
PCHAR DbgPowerMinorFunctionString(UCHAR MinorFunction);
PCHAR DbgSystemPowerString(SYSTEM_POWER_STATE Type);
PCHAR DbgDevicePowerString(DEVICE_POWER_STATE Type);

#endif  // _UTILS_H_

